
{
open Parse
} 

let ws = [' ' '\t' '\n']

rule lexer = parse
  ws+ { lexer lexbuf }
| '(' { LLParen }
| ')' { LRParen }
| '.' { LDot }
| ',' { LComma }
| "true" { LTrue }
| "false" { LFalse }
| "fn" { LFn }
| "if"   { LIf }
| "then" { LThen }
| "else" { LElse }
| "letcc" { LLetcc }
| "throw" { LThrow }
| '1' { LOne }
| '2' { LTwo }
| ['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9']*  { LVar (Lexing.lexeme lexbuf) }
| eof { LEof }
